%{
/*
 * This program is Copyright 1996 Mark Eichin, and is freely redistributable
 * under the terms of the GNU General Public License. See the file COPYING for
 * further details.
 */
#include <ctype.h>
#undef yywrap
%}
WSP [ \t]*
NL [ \t]*[\n\r]

ZERO	0
DECIMAL [1-9]

NONQUOTE [^"]

%%

[sS][hH][iI][fF][tT]	return MOD_SHIFT;
[nN][uU][mM]		return MOD_NUM;
[fF][uU][nN][cC]	return MOD_FUNC;
[cC][tT][rR][lL]	return MOD_CTRL;
[aA][lL][tT]		return MOD_ALT;
[mM][oO][uU][sS][eE]	return MOD_MOUSE;

[bB][aA][cC][kK][sS][pP][aA][cC][eE]	return KEYNAME_BSP;
[eE][nN][tT][eE][rR]	return KEYNAME_ENTER;
[eE][sS][cC]	return KEYNAME_ESC;
[tT][aA][bB]	return KEYNAME_TAB;

"\""{NONQUOTE}*"\""	{
			   yylval.string = stralloc(yytext+1);
			   yylval.string[strlen(yylval.string)-1] = 0;
		     /* printf("lex got quotedtext: <%s>\n",yylval.string); */
			   return QUOTEDTEXT;
			}

{DECIMAL}		yylval.number = atoi(yytext); return DECIMAL;

{ZERO}			yylval.number = 0; return ZERO;

{NL}			{ curr_line++; return NL;}

{WSP}			return WSP;

.			/* printf("lex a char: 0x%02x <%c>\n", *yytext, *yytext); */ return isupper(*yytext)?tolower(*yytext):*yytext;

